/*
pot est un programme servant  lister vos "pot" sur un rseau
Copyright (C) 2001 Fabien Carrion et Guillaume Pinot

Ce programme est libre, vous pouvez le redistribuer et/ou le modifier
selon les termes de la Licence Publique Gnrale GNU publie par la
Free Software Foundation (version 2).

Ce programme est distribu car potentiellement utile, mais SANS AUCUNE
GARANTIE, ni explicite ni implicite, y compris les garanties de
commercialisation ou d'adaptation dans un but
spcifique. Reportez-vous  la Licence Publique Gnrale GNU pour plus
de dtails.

Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en
mme temps que ce programme ; si ce n'est pas le cas, crivez  la
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307, tats-Unis.

fcarrion@etu.utc.fr
pinotgui@etu.utc.fr
*/

#include "commun.h"
#include "kelsal.h"

/* affiche un fichier sur stdout */
void view(char *chemin)
{
  /* initialisation des variables */
  int n = 0;
  char nom[10];
  FILE *pot;

  pot = fopen(chemin, "r");
  erreur(pot);

  /* affichage */
  while(fscanf(pot,"%9s",nom) != EOF)
    {
      n++;
      printf("%-13s",nom);
      if (n > 5)
        {
	  n = 0;
	  printf("\n");
        }
    }
  fclose(pot);
  printf("\n");
}


/* supprime un login de ~/.pot.pot */
void suppr(char *chemin,void *del)
{
  /* initialisation des variables */
  char nom[10];
  char *chemind;

  FILE *potd;
  FILE *pot = fopen(chemin, "r");

  if ( ( chemind = malloc( (strlen(chemin)+2)*sizeof(char) ) ) == NULL )
    {
      fprintf ( stderr , "Allocation de memoire impossible\n" );
      exit(0);
    }
 
  erreur(pot);
  strcpy(chemind,chemin);
  strcat(chemind,"2");
  /* verifier que chemind n'existe pas avant l'ouverture */
  potd = fopen(chemind, "a+");
  erreur(potd);
  while(fscanf(pot,"%9s",nom) != EOF)
    {
      if( strcmp(nom , del) != (int)NULL) 
        {
	  fprintf(potd , "%s\n" , nom);
        }
    }
  fclose(pot);
  fclose(potd);
  rename(chemind,chemin);
  remove(chemind);
}


/* gestion des erreurs  l'ouverture d'un flux */
void erreur(FILE *tube)
{
  if (!tube)
    {
      fprintf( stderr , "Erreur : %s\n" , strerror(errno));
      exit(0);
    }
}


/* remplit la stucture liste_connecte par rapport  localhost, renvoie
   le nombre de "pot", -1 si echoue */
int finger(char *chemin)
{
  /*initialisation des variables */
  int utm;
  char login[10];
  
  struct utmp whereis;
  struct passwd *user_info;
  
  FILE *pot;
  
  /* combien de personne dans la structure */
  int compteur = 0;
  
  /* Gestion de la liste des connectes */
  depart.next = NULL;
  depart.previous = NULL;
  connecte = &depart;

  /* Reprogrammation d'un finger sur mesure */

  /* ouverture des flux */
  if ( ( utm = open(UTMP, 0) ) < 0 )
    {
      fprintf(stderr,"***Warning*** %s\n" , strerror(errno) );
      return -1;
    }

  if ((pot = fopen(chemin, "r")) == NULL )
    {
      fprintf(stderr,"~/.pot.pot n'existe pas.\n"
	      "Pour plus d'informations tapez : pot -h\n");
      return -1;
    }

  /* lecture d'utmp */
  while ( read(utm,  (char *)&whereis, sizeof(struct utmp)) == sizeof(struct utmp))
    {
      /* Gain de temps car tous les logins ont au moins 2 caracteres */
      if (strlen(whereis.ut_user) > 1 )
        {
	  /* Recuperation des informations sur le login */
	  if ( (user_info = getpwnam(whereis.ut_user) ))
            {
	      /* la personne est-elle dans le fichier ~/.pot.pot */
	      while ( fscanf( pot , "%s" , login ) != EOF )
                {
		  if ( !strcmp( login , whereis.ut_user ) )
                    {
		      compteur++;

		      /* rajoute la personne connect dans la structure liste-connecte */
		      if (  ! ajouteliste ( whereis.ut_user , whereis.ut_host , whereis.ut_line , user_info ) )
			return -1;
                    }
                }
	      /* reinitialisation du flux pot */
	      fseek( pot , 0 , SEEK_SET );
            }
        }
    }

  /* fermeture des flux */
  fclose( pot );
  close( utm );
  
  return compteur;
}


/* la fonction rajoute un connecte, 0 quand choue, 1 sinon */
int ajouteliste(char *login , char *ordi , char *tty , struct passwd *ki)
{
  
  /* Creation de la structure suivante */

  if ( ( connecte = (struct liste_connecte *) malloc(sizeof(struct liste_connecte)) ) == NULL )
    {
      fprintf ( stderr , "Allocation de memoire impossible\n" );
      return 0;
    }

  connecte->next = depart.next;
  depart.next = connecte;
  connecte->previous = &depart;
  if( connecte->next != NULL)
    connecte->next->previous = connecte;

  /* remplissage de la structure */

  /* login */
  if ( ( connecte->login = (char *) calloc(strlen(login) + 1, sizeof(char)) ) == NULL )
    {
      fprintf ( stderr , "Allocation de memoire impossible\n" );
      return 0;
    }
  strcpy(connecte->login,login);

  /* ordi */
  if ( ( connecte->ordi = (char *) calloc(strlen(ordi) + 1, sizeof(char)) ) == NULL )
    {
      fprintf ( stderr , "Allocation de memoire impossible\n" );
      return 0;
    }
  strcpy(connecte->ordi,ordi);
  
  /* nom */
  if ( ki->pw_gecos[0] != ',' && ki->pw_gecos[0] != '\0' )
    {
      if ( ( connecte->nom = (char *) calloc(strlen(ki->pw_gecos) + 1, sizeof(char)) ) == NULL )
        {
	  fprintf ( stderr , "Allocation de memoire impossible\n" );
	  return 0;
        }
      strcpy( connecte->nom,strtok(ki->pw_gecos,",") );
    }
  else
    {
      if ( ( connecte->nom = (char *) malloc (sizeof("???")) ) == NULL )
        {
	  fprintf ( stderr , "Allocation de memoire impossible\n" );
	  return 0;
        }
      strcpy(connecte->nom,"???");
    }

  
  /* talk */
  connecte->talk = talkable(tty);
  
  /* salle */
  if ( (connecte->salle = kelsal(ordi)) == NULL )
    {
      fprintf ( stderr , "Probleme avec le fichier de configuration\n" );
      return 0;
    }
  
  return 1;
}

/* la fonction retourne 1 si on peut communiquer avec la personne sinon 0 */
short talkable( char *tty )
{
  /* initialisation des variables */
  struct stat ttystatus;
  char *buffer;

  /* Si sur samba */
  if ( ! strcmp(tty,"smb") )
    return 0;

  /* recuperation du nom de la console */
  if ( ( buffer = (char *)malloc((strlen(tty)+6)*sizeof(char)) ) == NULL )
    {      
      fprintf ( stderr , "Allocation de memoire impossible\n" );
      return 0;
    }

  strcpy( buffer , "/dev/" );
  strcat(buffer,tty);

  /* recuperation du mode d'ecriture de la console */
  if (stat(buffer, &ttystatus) < 0)
      return 0;

  /* retour de la fonction : console ecrivable ou non */
  if( (ttystatus.st_mode & TALKABLE) == TALKABLE )
    return 1;
  else
    return 0;
}


#ifdef SAMBA
/* la fonction scanne les connecte par samba (PC), renvoie le nombre de "pot", -1 si echoue */
int samba(char *chemin)
{
  /* initialisation des variable */
  int compteur = 0;
  int tmp = 1;
  
  char login[10];
  char ordi[10];
  char *talk = "smb";
  
  struct passwd* user_info;
  
  FILE *smb;
  
  /* ouverture de la commande sambastatus */
  smb = (FILE *) popen("smbstatus -b | cut -c9-28 | grep -f $HOME/.pot.pot","r");
  erreur(smb);

  /* lecture du flux */
  while( (fscanf(smb,"%s",login) != EOF) && (fscanf(smb,"%s",ordi) != EOF) )
    {
      if ( ! (user_info = getpwnam(login)) )
	break;
      compteur++;

      /* La personne a-elle une console active */
      connecte = &depart;

      while ( (connecte = connecte->next) != NULL )
        {
	  tmp = 1; 
		  
	  if ( ! strcmp(login,connecte->login) )
            {
	      tmp = 0;
	      break;
            }
        }
      /* rajoute la personne connect dans la structure liste-connecte */
      if (tmp == 1)
        {
	  connecte = &depart;
	  if (  ! ajouteliste ( login , ordi , talk , user_info ) )
	    return -1;
        }
      
    }
  pclose(smb);
  return compteur;
}
#endif


/* efface la liste chaine */
int free_liste( void )
{
  struct liste_connecte *efface;
  
  if ( (efface = depart.next) == NULL )
    return 0;
  
  /* Ca marche mais c est vraiment pas beau */
  while( efface->next != NULL )
    {
      free( efface->login );
      free( efface->ordi );
      free( efface->nom );
      free( efface->salle );
      efface = efface->next;
      free( efface->previous );
    }

  free( efface->login );
  free( efface->ordi );
  free( efface->nom );
  free( efface->salle );
  free( efface );

  return 0;
}
